const express = require('express');
const router = express.Router();
const api = require('../utils/api-connector');

module.exports = loginView => {
  router.get('/', (req, res) => {
    if (loginView) {
      return res.sendFile(loginView);
    }

    res.render('login');
  });

  router.post('/', function (req, res) {
    const username = req.body.username;
    const password = req.body.password;
    const clientId = req.body.clientId;

    req.uri = `${req.environment.hosts.auth}/token?grant_type=password&username=${username}&password=${password}&client_id=${clientId}`;

    api.post(req, function(error, response, body) {
      if (!error) {
        req.session.user = body;
        req.session.user.name = username;
      }

      res.status(response.statusCode).json(error || body);
    });
  });

  return router;
};