const path = require("path");

module.exports = function (config = {}) {
  return {
    entry: config.entries,
    target: 'web',
    devtool: 'eval',
    output: {
      path: config.path,
      filename: "js/[name].bundle.js"
    },
    resolve: {
      modules: [
        "web_modules",
        "node_modules"
      ]
    },
    module: {
      rules: [
        {
          test: /\.js$/,
          include: config.include,
          exclude: /node_modules/,
          loader: 'babel-loader',
          options: {
            sourceMaps: 'inline'
          }
        },
        {test: /\.eot(\?v=\d+.\d+.\d+)?$/, loader: 'file-loader'},
        {test: /\.(woff|woff2)$/, loader: 'file-loader?prefix=font/&limit=5000'},
        {test: /\.ttf(\?v=\d+.\d+.\d+)?$/, loader: 'file-loader?limit=10000&mimetype=application/octet-stream'},
        {test: /\.svg(\?v=\d+.\d+.\d+)?$/, loader: 'file-loader?limit=10000&mimetype=image/svg+xml'},
        {test: /\.(jpe?g|png|gif)$/i, use: ['file']},
        {test: /\.ico$/, loader: 'file-loader?name=[name].[ext]'},
        {test: /\.json$/, loader: 'json-loader'},
        {test: /(\.css)$/, use: ['style-loader', 'css-loader?sourceMap']},
        {test: /(\.styl)$/, use: ['style-loader', 'css-loader?sourceMap', 'stylus-loader?sourceMap']}
      ]
    }
  }
};